# ══════════════════════════════════════════════════════════════════
# Sécurité — security.yaml
# ══════════════════════════════════════════════════════════════════
# Configuration complète du composant Security de Symfony.
#
# Résumé de l'architecture :
#   • Fournisseur     : App\Entity\User identifié par son champ email
#   • Hachage         : algorithme auto (bcrypt ou argon2i selon PHP)
#   • UserChecker     : App\Security\UserChecker bloque les comptes inactifs
#   • Authentification: form_login avec CSRF activé
#   • Anti-brute-force: login_throttling (5 tentatives / 15 min)
#   • Remember-me     : cookie sécurisé, 7 jours, SameSite=Lax
#   • Contrôle d'accès:
#       /login          → PUBLIC_ACCESS (non authentifié autorisé)
#       /admin/**       → ROLE_ADMIN uniquement
#       tout le reste   → ROLE_USER (tout utilisateur connecté)
# ══════════════════════════════════════════════════════════════════
security:
    # ── Hachage des mots de passe ──────────────────────────────────
    # "auto" laisse Symfony choisir le meilleur algorithme disponible
    # (bcrypt par défaut, argon2i si l'extension PHP est présente).
    password_hashers:
        App\Entity\User:
            algorithm: auto

    # ── Fournisseur d'utilisateurs ─────────────────────────────────
    # Charge l'utilisateur depuis la table `user` via Doctrine,
    # en utilisant l'adresse e-mail comme identifiant unique.
    providers:
        app_user_provider:
            entity:
                class: App\Entity\User
                property: email

    # ── Pare-feu ───────────────────────────────────────────────────
    firewalls:
        # Désactive la sécurité sur les routes internes Symfony
        # (profiler, web debug toolbar, assets) en environnement dev.
        dev:
            pattern: ^/(_profiler|_wdt|assets|build)/
            security: false

        # Pare-feu principal : couvre toutes les routes de l'application.
        main:
            lazy: true                                # Session créée seulement si nécessaire
            provider: app_user_provider
            user_checker: App\Security\UserChecker    # Bloque les comptes inactifs (actif=false)

            # Authentification par formulaire
            form_login:
                login_path: app_login      # Route du formulaire de connexion
                check_path: app_login      # Route de traitement du POST
                enable_csrf: true          # Jeton CSRF sur le formulaire
                default_target_path: app_dashboard  # Redirection après connexion réussie

            # Protection anti-brute-force intégrée à Symfony
            login_throttling:
                max_attempts: 5            # Nombre de tentatives maximum
                interval: '15 minutes'     # Fenêtre glissante de blocage

            # Déconnexion
            logout:
                path: app_logout           # Route qui déclenche la déconnexion
                target: app_login          # Redirection vers le login après déconnexion

            # Cookie "Se souvenir de moi"
            remember_me:
                secret: '%kernel.secret%'  # Clé de signature du cookie (APP_SECRET)
                lifetime: 604800           # 7 jours en secondes
                secure: auto               # HTTPS uniquement si disponible
                samesite: lax              # Protection CSRF via SameSite
                httponly: true             # Inaccessible depuis JavaScript

    # ── Contrôle d'accès ───────────────────────────────────────────
    # Les règles sont évaluées dans l'ordre ; la première correspondance gagne.
    access_control:
        - { path: ^/login, roles: PUBLIC_ACCESS }   # Formulaire de connexion accessible à tous
        - { path: ^/admin, roles: ROLE_ADMIN }       # Section admin réservée aux admins
        - { path: ^/, roles: ROLE_USER }             # Reste de l'app : utilisateur connecté requis

# ── Environnement de test ─────────────────────────────────────────
# Coûts de hachage réduits au minimum pour accélérer les tests.
when@test:
    security:
        password_hashers:
            # Password hashers are resource-intensive by design to ensure security.
            # In tests, it's safe to reduce their cost to improve performance.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
